;**************************************************************
;***    EMS560.ASM                                          ***
;***                                                        ***
;***    function        EMS_EmBlk.mapPagesCallNum40(        ***
;***                        var buffer:     Word)           ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Transfers control to EMS location mapped by phys.   ***
;***    page by CALL                                        ***
;***                                                        ***
;***    Returns 0 if no error or an error code.             ***
;***                                                        ***
;***                                                        ***
;***                                                        ***
;***    (Ems Version 4.0)                                   ***
;**************************************************************

        .model  large,pascal   

        include emsdefs.asm 

        extrn   errno:WORD  

;
;   Define entry point
;
        public  EMS_EmBlk@mapPagesCallNum40

        .code

EMS_EmBlk@mapPagesCallNum40 proc buffer:Far Ptr DWord, handle:Far Ptr Word

        push    ds                      ; Save regs
        push    si

        les     bx,handle
        mov     dx,es:[bx]              ; DX gets EMS handle
        lds     si,buffer               ; DS:SI gets buffer address

        mov     ax,MapPagesCallNum40    ; Make EMS call
        int     Ems           

        or      ah,ah                   ; Set flags
        jnz     error

        xor     ax,ax                   ; Return OK
        pop     si                      ; Restore regs
        pop     ds
        ret         

error:
        pop     si                      ; Restore regs
        pop     ds

        mov     al,ah                   ; AL gets error code
        xor     ah,ah                   ; Zero extend
        mov     errno,ax                ; Save in errno too
        ret

EMS_EmBlk@mapPagesCallNum40 endp        ; End of procedure

        end                             ; End of source file
